;========================   ======================
;=========================================
;  : main.asm
; : 07.06.09
; :   
; E-mail: cq4n@yandex.ru
; : 1.00 2.07.2009
;==================================================================
;   PIC12F629.  .
;==================================================================
;  
;    .   7   
; . 6   .
;==================================================================


;================================================
;    
;================================================
	LIST  p=12F629
	__CONFIG H'3FE4'

;================================================
;    
;================================================

INTCON			equ 0x0B
STATUS			equ 0x03
PORTGP			equ 0x05
TRISGP			equ 0x85
CMCON           equ 0x19 

;================================================
;  
;================================================

RP0			equ 0x05

;---   '' -------------------------------------------------
CW	        EQU	0	; GP0  CW 
PTT         EQU 1   ; GP1  PTT

;================================================
;     
;================================================

A1			equ 0x20
A2          equ 0x21
A3          equ 0x22
B1          equ 0x23
;================================================
;  
;================================================
	ORG 0x00
	goto Start


	ORG 0x05

Start:
	clrf INTCON			;  

;===============================================
;    PORTB  
;===============================================

	bsf STATUS, RP0 			;   1
    clrf TRISGP
	bcf STATUS, RP0	     		;   0

    movlw 0x07     ; PORTGP  /
    movwf CMCON

;===============================================
;  
;===============================================
     goto Start2 ;   

;------- ,  --------
Beep:
     movlw .190
     movwf B1
     call Set1       ; 
Loop9:    
     decfsz B1, F    ;,      1  0    
     goto Loop9

     call Set0       ; 
     movlw .190
     movwf B1 
Loop10: 
    decfsz B1, F    ;,      1  0    
    goto Loop10
    return


;-----    CW --------

Set1:
     movlw b'00000011'
     movwf PORTGP
     return
Set0:
     movlw b'00000010'
     movwf PORTGP
     return

;----- , , --------

PauseZnak:              ;   100 ms
    movlw .255
    movwf A1
	movlw .130 			;    255
	movwf A2			;      A1
Loop1:
    decfsz A1, F        ;,      1  0    
    goto Loop1
loop13:
    decfsz A2,f
    goto Loop1
    RETURN
;----------------------------------------------------------------
PauseSlovo:             ;     400 ms
	movlw .100 			;    100
	movwf A1			;      A1
    movlw .10
    movwf A2
    movlw .3
    movwf A3
Loop2:
    decfsz A1, F        ;,      1  0    
    goto Loop2
    decfsz A2,F
    goto Loop2
    decfsz A3,F
    goto Loop2
    RETURN
;-------------------------------------------------------------------
Tire:               ;  300 ms
 	movlw .50 			;    71
	movwf A1			;      A1
    movlw .2
    movwf A2
Loop3:
    call Beep       ;
    decfsz A1, F    ;,      1  0    
    goto Loop3
    decfsz A2,F
    goto Loop3
    nop
    call PauseZnak
    RETURN

Tochka  ;   100 ms
   	movlw .102 			;    102
	movwf A1			;      A1
    movlw .1
    movwf A2
Loop4:
    call Beep       ;
    decfsz A1, F    ;,      1  0    
    goto Loop4
    decfsz A2,F
    goto Loop4
    nop
    call PauseZnak
    RETURN

PauseBig:       ;   500 ms
    movlw .255 			;    255
	movwf A1			;      A1
    movlw .137
    movwf A2
    movlw .3
    movwf A3
Loop5:
    decfsz A1, F    ;,      1  0    
    goto Loop5
    decfsz A2,F
    goto Loop5
    decfsz A3,F
    goto Loop5
    RETURN

;--------   -------------
BkvA:
    call Tochka
    call Tire
    call PauseSlovo
    return
BkvB:
    call Tire
    call Tochka
    call Tochka
    call Tochka
    call PauseSlovo
    return
BkvC:
    call Tire
    call Tochka
    call Tire
    call Tochka
    call PauseSlovo
    return
BkvD:
    call Tire
    call Tochka
    call Tochka
    call PauseSlovo
    return
BkvE:
   call Tochka
   call PauseSlovo
   return
BkvF:
   call Tochka
   call Tochka
   call Tire
   call Tochka
   call PauseSlovo
   return
BkvG:
   call Tire
   call Tire
   call Tochka
   call PauseSlovo
   return
BkvH:
   call Tochka 
   call Tochka
   call Tochka
   call Tochka
   call PauseSlovo
   return
BkvI:
   call Tochka
   call Tochka
   call PauseSlovo
   return
BkvJ:
   call Tochka
   call Tire
   call Tire
   call Tire
   call PauseSlovo
   return
BkvK:
   call Tire
   call Tochka
   call Tire
   call PauseSlovo
   return
BkvL:
   call Tochka
   call Tire
   call Tochka
   call Tochka
   call PauseSlovo
   return
BkvM:
   call Tire
   call Tire
   call PauseSlovo
   return
BkvN:
   call Tire
   call Tochka
   call PauseSlovo
   return
BkvO:
   call Tire
   call Tire
   call Tire
   call PauseSlovo
   return
BkvP:
   call Tochka
   call Tire
   call Tire
   call Tochka
   call PauseSlovo
   return
BkvQ:
   call Tire
   call Tire
   call Tochka
   call Tire
   call PauseSlovo
   return
BkvR:
   call Tochka
   call Tire
   call Tochka
   call PauseSlovo
   return
BkvS:
   call Tochka
   call Tochka
   call Tochka
   call PauseSlovo
   return
BkvT:
   call Tire
   call PauseSlovo
   return
BkvU:
   call Tochka
   call Tochka
   call Tire
   call PauseSlovo
   return
BkvV:
   call Tochka
   call Tochka
   call Tochka
   call Tire
   call PauseSlovo
   return
BkvW:
   call Tochka
   call Tire
   call Tire
   call PauseSlovo
   return
BkvX:
   call Tire
   call Tochka
   call Tochka
   call Tire
   call PauseSlovo
   return
BkvY:
   call Tire
   call Tochka
   call Tire
   call Tire
   call PauseSlovo
   return
BkvZ:
   call Tire
   call Tire
   call Tochka
   call Tochka
   call PauseSlovo
   return
Cif4:
   call Tochka
   call Tochka
   call Tochka
   call Tochka
   call Tire
   call PauseSlovo
   return
Cif8:
   call Tire
   call Tire
   call Tire
   call Tochka
   call Tochka
   call PauseSlovo
   return
;----------  --------

;-------   -----

Start2:

    bsf PORTGP, PTT  ;  ,  
 
;---------- 2 .    ------
    movlw .255 			;    100
	movwf A1			;      A1
    movlw .255
    movwf A2
    movlw .10
    movwf A3
Loop6:
    decfsz A1, F    ;,      1  0    
    goto Loop6
Loop11:
    decfsz A2, F
    goto Loop6
Loop12:
    decfsz A3,F
    goto Loop6
    nop
;----------------------------------------------------------------

;  "CQ DE BEACON PMR DRUZHBA LO48TN K"
    call BkvC
    call BkvQ
    Call PauseBig
    call BkvC
    call BkvQ
    Call PauseBig
    call BkvD
    call BkvE
    call PauseBig
    call BkvB
    call BkvE
    call BkvA
    call BkvC
    call BkvO
    call BkvN 
    call PauseBig
    call BkvP
    call BkvM
    call BkvR
    call PauseBig
    call BkvD
    call BkvR
    call BkvU
    call BkvZ
    call BkvH
    call BkvB
    call BkvA
    call PauseBig
    call BkvL
    call BkvO
    call Cif4
    call Cif8
    call BkvT
    call BkvN
    call PauseBig
    call BkvK
    
    nop
;---- ,  5s ----
    call Set1
    movlw .255 			;    255
	movwf A1			;      A1
    movlw .19
    movwf A2
 ;   movlw .25     ;    
 ;   movwf A3
Zad:
   call Beep     ;
   decfsz A1,F
   goto Zad
   decfsz A2,F
   goto Zad
;   decfsz A3,F    ;   
;   goto Zad

   clrf PORTGP  ;  


;    50 s

    movlw .255 			;    255
	movwf A1			;      A1
    movlw .255
    movwf A2
    movlw .255
    movwf A3
    
Loop7:
    decfsz A1, F    ;,      1  0    
    goto Loop7
    decfsz A2,F
    goto Loop7
    decfsz A3,F
    goto Loop7
    nop

    goto Start2  ;  

	End
